uniform float outlineSize; 
uniform vec3 outlineColor; 
uniform vec2 textureSize; 
uniform vec3 foregroundColor;

varying vec4 v_fragmentColor; 
varying vec2 v_texCoord; 

int getIsStrokeWithAngel(float angel)
{
	int stroke = 0;
	float rad = angel * 0.01745329252; 
	float a = texture2D(
	CC_Texture0, 
	vec2(v_texCoord.x + outlineSize * cos(rad) / textureSize.x, 
		 v_texCoord.y + outlineSize * sin(rad) / textureSize.y)).a;
	if (a > 0.0)
	{
		stroke = 1;
	}
	return stroke;
}

void main(void)
{
	vec4 myC = texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y));
	myC.rgb *= foregroundColor;
	if (myC.a >= 0.1) 
	{
		gl_FragColor = v_fragmentColor * myC;
		return ;
	}
	int strokeCount = 0;
	strokeCount += getIsStrokeWithAngel(0.0);
	strokeCount += getIsStrokeWithAngel(7.5);
	strokeCount += getIsStrokeWithAngel(15.0);
	strokeCount += getIsStrokeWithAngel(22.5);
	strokeCount += getIsStrokeWithAngel(30.0);
	strokeCount += getIsStrokeWithAngel(37.5);
	strokeCount += getIsStrokeWithAngel(45.0);
	strokeCount += getIsStrokeWithAngel(52.5);
	strokeCount += getIsStrokeWithAngel(60.0);
	strokeCount += getIsStrokeWithAngel(67.5);
	strokeCount += getIsStrokeWithAngel(75.0);
	strokeCount += getIsStrokeWithAngel(82.5);
	strokeCount += getIsStrokeWithAngel(90.0);
	strokeCount += getIsStrokeWithAngel(97.5);
	strokeCount += getIsStrokeWithAngel(105.0);
	strokeCount += getIsStrokeWithAngel(112.5);
	strokeCount += getIsStrokeWithAngel(120.0);
	strokeCount += getIsStrokeWithAngel(127.5);
	strokeCount += getIsStrokeWithAngel(135.0);
	strokeCount += getIsStrokeWithAngel(142.5);
	strokeCount += getIsStrokeWithAngel(150.0);
	strokeCount += getIsStrokeWithAngel(157.5);
	strokeCount += getIsStrokeWithAngel(165.0);
	strokeCount += getIsStrokeWithAngel(172.5);
	strokeCount += getIsStrokeWithAngel(180.0);
	strokeCount += getIsStrokeWithAngel(187.5);
	strokeCount += getIsStrokeWithAngel(195.0);
	strokeCount += getIsStrokeWithAngel(202.5);
	strokeCount += getIsStrokeWithAngel(210.0);
	strokeCount += getIsStrokeWithAngel(217.5);
	strokeCount += getIsStrokeWithAngel(225.0);
	strokeCount += getIsStrokeWithAngel(232.5);
	strokeCount += getIsStrokeWithAngel(240.0);
	strokeCount += getIsStrokeWithAngel(247.5);
	strokeCount += getIsStrokeWithAngel(255.0);
	strokeCount += getIsStrokeWithAngel(262.5);
	strokeCount += getIsStrokeWithAngel(270.0);
	strokeCount += getIsStrokeWithAngel(277.5);
	strokeCount += getIsStrokeWithAngel(285.0);
	strokeCount += getIsStrokeWithAngel(292.5);
	strokeCount += getIsStrokeWithAngel(300.0);
	strokeCount += getIsStrokeWithAngel(307.5);
	strokeCount += getIsStrokeWithAngel(315.0);
	strokeCount += getIsStrokeWithAngel(322.5);
	strokeCount += getIsStrokeWithAngel(330.0);
	strokeCount += getIsStrokeWithAngel(337.5);
	strokeCount += getIsStrokeWithAngel(345.0);
	strokeCount += getIsStrokeWithAngel(352.5);

	if (strokeCount > 0)
	{
		myC.rgb = outlineColor;
		myC.a = 1.0;
	}

	gl_FragColor = v_fragmentColor * myC;
}
